## gecode 1.0.0.dfsg.1

=== contribs/graph/Makefile ===
# Author Grgoire Dooms
# Copied from Gecode Makefile.in
# The gecode configure script makes the Makefile.in from this Makefile.in.in
# Then the cp(Graph) configure script makes the Makefile from the Makefile.in

# get variables from top Makefile
#
gecode_top_srcdir = $(top_srcdir)
cpgraph_top_srcdir = $(curdir)


KERNELDLL := $(KERNELDLL:%=../../%)
SETDLL := $(SETDLL:%=../../%)
INTDLL := $(INTDLL:%=../../%)
SUPPORTOBJ := $(SUPPORTOBJ:%=../../%)

ifeq "$(LIBPREFIX)" "$(LINKPREFIX)"
LINKSET:=../../$(LINKSET)
LINKKERNEL:=../../$(LINKKERNEL)
LINKINT:=../../$(LINKINT)
LINKMM:=../../$(LINKMM)
LINKSEARCH:=../../$(LINKSEARCH)
LINKALL := $(LINKMM) $(LINKSET) $(LINKINT) $(LINKSEARCH) $(LINKKERNEL)
else
EXTRALINKFLAGS := -L../..
endif

#
# GRAPH COMPONENTS
#

GRAPHSRC0 = view/arcnode.cc 
GRAPHHDR0 = view/outadjsets.icc view/constant.icc view/arcnode.hh view/nodearcsets.icc graphutils.icc  var.icc view.icc graphutils.h view/boundsgraphs.icc view/prop.icc path/path.icc path/pathgraphs.icc path.hh path.icc
#GRAPHHDR0 = @GRAPHHDR@


GRAPHSRC		= $(GRAPHSRC0)
GRAPHHDR		= graph.hh $(GRAPHHDR0)
GRAPHOBJ		= $(GRAPHSRC:%.cc=%$(OBJSUFFIX))
GRAPHFLAGS      = -I/usr/local/boost-cvs/ -I../.. $(EXTRALINKFLAGS)
GRAPHDLL		= $(LIBPREFIX)graph$(DLLSUFFIX)
GRAPHSTATICLIB	= $(LIBPREFIX)graph$(STATICLIBSUFFIX)
GRAPHLIB		= $(LIBPREFIX)graph$(LIBSUFFIX)
LINKGRAPH      	= $(LINKPREFIX)graph$(LINKSUFFIX)
#GRAPHBUILDDIRS	= view

ifeq "$(LIBPREFIX)" "$(LINKPREFIX)"
LINKGRAPH := $(LINKGRAPH)
else
EXTRALINKFLAGS := -L../..
endif

LINKALL := $(LINKALL) $(LINKGRAPH)

#
# GRAPH EXAMPLES
#

GRAPHEXAMPLESRC0 = cpgraph-basic cpgraph-path cpgraph-complement cpgraph-path2 cpgraph-instUB cpgraph-pathcost
GRAPHEXAMPLESRC  = $(GRAPHEXAMPLESRC0:%=examples/%.cc)
GRAPHEXAMPLEOBJ  = $(GRAPHEXAMPLESRC:%.cc=%$(OBJSUFFIX))
GRAPHEXAMPLESBJ  = $(GRAPHEXAMPLESRC:%.cc=%$(SBJSUFFIX))
GRAPHEXAMPLEEXE  = $(GRAPHEXAMPLESRC:%.cc=%$(EXESUFFIX))
GRAPHEXAMPLEBUILDDIRS = examples/

GRAPHEXAMPLEHDR0 = $(gecode_top_srcdir)/support.hh $(gecode_top_srcdir)/support.icc $(gecode_top_srcdir)/timer.hh
GRAPHEXAMPLEHDR  = $(GRAPHEXAMPLEHDR0:%=../../examples/%) $(GRAPHHDR)

ALLLIB :=  $(ALLLIB) $(GRAPHLIB) 


LIBTARGETS = $(GRAPHDLL) $(GRAPHLIB)

all : $(LIBTARGETS) $(GRAPHEXAMPLEEXE)

#
# Object targets
#


examples/%$(OBJSUFFIX): examples/%.cc
	$(CXX) $(CXXFLAGS) $(EXAMPLES_EXTRA_CXXFLAGS) $(GRAPHFLAGS)\
	-c -o $@  $<
examples/%$(SBJSUFFIX): examples/%.cc
	$(CXX) $(CXXFLAGS) $(EXAMPLES_EXTRA_CXXFLAGS) $(GRAPHFLAGS)\
	-S -o $@  $<

%$(OBJSUFFIX): %.cc
	$(CXX) $(CXXFLAGS) -DGECODE_BUILD_GRAPH $(GRAPHFLAGS)\
	-c -o $@  $<
%$(SBJSUFFIX): %.cc
	$(CXX) $(CXXFLAGS) -DGECODE_BUILD_GRAPH  $(GRAPHFLAGS)\
	-S -o $@  $<

#
# DLL Targets
#

ifeq "$(DLLSUFFIX)" "$(LIBSUFFIX)" 
#linux 
$(GRAPHDLL): $(GRAPHOBJ) $(KERNELDLL) $(INTDLL) $(SETDLL)
	$(CXX) $(DLLFLAGS) $(GRAPHOBJ)  $(GRAPHFLAGS)\
		-L. $(LINKKERNEL) $(LINKINT) \
		-o $(GRAPHDLL)
else
#win
$(GRAPHDLL) $(GRAPHLIB): $(GRAPHOBJ) $(KERNELDLL) $(INTDLL) $(SETDLL)
	$(CXX) $(DLLFLAGS) $(GRAPHOBJ)  $(GRAPHFLAGS)\
		-L. $(LINKKERNEL) $(LINKINT) $(LINKSET) \
		-o $(GRAPHDLL)
endif

# 
# EXE targets
#
#


.PRECIOUS: examples/%$(OBJSUFFIX)
examples/%$(EXESUFFIX): examples/%$(OBJSUFFIX) $(SUPPORTOBJ) $(ALLIB)
	$(CXX) -o $@ $< $(SUPPORTOBJ) $(DLLPATH) $(CXXFLAGS) $(GRAPHFLAGS)\
	$(LDFLAGS) $(LINKALL)
CXXFLAGS := $(CXXFLAGS) $(GRAPHFLAGS) 

	
.PHONY: doc
doc: $(GRAPHHDR) $(GRAPHSRC) 
	mkdir -p doc/html
	doxygen doxygen.conf

#
# Autoconf
#

configure: configure.ac 
	autoconf
config.status: configure
	../../config.status --recheck
	./config.status --recheck
Makefile: Makefile.in config.status
	./config.status
Makefile.in : Makefile.in.in ../../config.status
	../../config.status --file $@:$<


.PHONY: clean veryclean distclean
localclean:
	find  examples -perm +u+x -not -type d -exec rm '{}' ';'
	rm libgecodegraph.so

clean:
	$(RMF) $(GRAPHOBJ) $(GRAPHSBJ)

veryclean: clean
	$(RMF) $(LIBTARGETS)
	$(RMF) $(LIBTARGETS:%$(DLLSUFFIX)=%.exp) $(LIBTARGETS:%$(DLLSUFFIX)=%.lib)
	$(RMF) $(LIBTARGETS:%$(DLLSUFFIX)=%.ilk) $(LIBTARGETS:%$(DLLSUFFIX)=%.pdb)
	$(RMF) $(GRAPHEXAMPLEEXE:%$(EXESUFFIX)=%.pdb)
	$(RMF) $(GRAPHEXAMPLEEXE:%$(EXESUFFIX)=%$(OBJSUFFIX))
	$(RMF) $(GRAPHEXAMPLEEXE:%$(EXESUFFIX)=%$(SBJSUFFIX))
	$(RMF) doc CPGraphReference.chm 
	$(RMF) $(GRAPHEXAMPLEEXE)

distclean: veryclean
	$(RMF) config.log config.status Makefile.in

## gecode 1.3.1

=== contribs/graph/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 GRAPHSRC		= $(GRAPHSRC0)
 GRAPHHDR		= graph.hh $(GRAPHHDR0)
 GRAPHOBJ		= $(GRAPHSRC:%.cc=%$(OBJSUFFIX))
-GRAPHFLAGS      = -I/usr/local/boost-cvs/ -I../.. $(EXTRALINKFLAGS)
+GRAPHFLAGS      = -I/usr/local/boost-cvs/ -I../.. -I../../gecode $(EXTRALINKFLAGS)
 GRAPHDLL		= $(LIBPREFIX)graph$(DLLSUFFIX)
 GRAPHSTATICLIB	= $(LIBPREFIX)graph$(STATICLIBSUFFIX)
 GRAPHLIB		= $(LIBPREFIX)graph$(LIBSUFFIX)
@@ -101,7 +101,9 @@
 $(GRAPHDLL): $(GRAPHOBJ) $(KERNELDLL) $(INTDLL) $(SETDLL)
 	$(CXX) $(DLLFLAGS) $(GRAPHOBJ)  $(GRAPHFLAGS)\
 		-L. $(LINKKERNEL) $(LINKINT) \
-		-o $(GRAPHDLL)
+		-o $(GRAPHDLL) &&\
+	$(CREATELINK) $@ $(@:%$(DLLSUFFIX)=%$(SOLINKSUFFIX)) && \
+	$(CREATELINK) $@ $(@:%$(DLLSUFFIX)=%$(SOSUFFIX))
 else
 #win
 $(GRAPHDLL) $(GRAPHLIB): $(GRAPHOBJ) $(KERNELDLL) $(INTDLL) $(SETDLL)

## gecode 3.3.1

=== debian/changelog ===
gecode (3.3.1-2) unstable; urgency=low

  * Add correct pkg-config QtGui calls to examples/Makefile in
    libgecode-doc.

 -- Kari Pahula <kaol@debian.org>  Sat, 01 May 2010 19:58:24 +0300

gecode (3.3.1-1) unstable; urgency=low

  * New upstream release (soname 22)

 -- Kari Pahula <kaol@debian.org>  Sat, 01 May 2010 01:12:01 +0300

gecode (3.3.0-2) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format
  * Use -O2 on ia64 to avoid #568399.
  * Patch gecode.m4 to not force using -O3.
  * Add autoconf and automake as a build deps and run autoreconf in
    debian/rules.

 -- Kari Pahula <kaol@debian.org>  Tue, 16 Mar 2010 23:11:28 +0200

gecode (3.3.0-1) unstable; urgency=low

  * New upstream release (soname 21)

 -- Kari Pahula <kaol@debian.org>  Tue, 16 Mar 2010 14:19:41 +0200

gecode (3.2.2-1) unstable; urgency=low

  * New upstream release (soname 20)
  * Standards-Version: 3.8.4 (no changes needed)
  * Disable building static libraries.

 -- Kari Pahula <kaol@debian.org>  Sun, 14 Feb 2010 19:03:01 +0200

gecode (3.2.1-1) unstable; urgency=low

  * New upstream release (soname 19)

 -- Kari Pahula <kaol@debian.org>  Tue, 10 Nov 2009 22:02:14 +0200

gecode (3.2.0-1) unstable; urgency=low

  * New upstream release (soname 18)
  * Fixed a bashism in debian/rules. (Closes: #535382)
  * Standards-Version bumped to 3.8.3 (no changes needed).
  * Dropped the .pc files since upstream no longer provides them and
    adjusted the examples' Makefile accordingly.
  * Build and include FlatZinc executable (fz) in libgecode-dev.

 -- Kari Pahula <kaol@debian.org>  Sun, 01 Nov 2009 15:52:31 +0200

gecode (3.1.0-1) unstable; urgency=low

  * New upstream release (soname 17) (Closes: #526675)
  * Run "make check" instead of test/test.
  * Build depend on libboost-dev, not libboost1.37-dev. (Closes: #534061)
  * Standards-Version bumped to 3.8.2 (no changes necessary).
  * Explicitly add -lgecodedriver to the LDFLAGS in the provided Makefile
    for examples in libgecode-doc.

 -- Kari Pahula <kaol@debian.org>  Sat, 27 Jun 2009 22:29:21 +0300

gecode (3.0.2-1) unstable; urgency=low

  * New upstream release (soname 16)

 -- Kari Pahula <kaol@debian.org>  Fri, 27 Mar 2009 10:40:36 +0200

gecode (3.0.0-2) unstable; urgency=low

  * Removed the information about BuDDy library from debian/copyright
    (Gecode no longer includes or uses it).

 -- Kari Pahula <kaol@debian.org>  Fri, 20 Mar 2009 13:26:05 +0200

gecode (3.0.0-1) unstable; urgency=low

  * New upstream release (soname 14) (Closes: #507112)
    * Fixed build error with GCC 4.4 (Closes: #505081)
  * Dropped the number from the libgecode*-dev package.
  * Replaced libboost-serialization-dev with libboost1.37-dev as a
    Build-Dep.
  * Recognize parallel=n build option (Closes: #484101)
  * Enable running test suite on s390.
  * Standards-Version 3.8.1.
  * Enable building the Gecode Interactive Search Tool.
    * Build-Depends: libqt4-dev, Build-Conflicts: qt3-dev-tools.
  * Build float variable library (--enable-float-vars).

 -- Kari Pahula <kaol@debian.org>  Wed, 18 Mar 2009 23:59:42 +0200

gecode (2.1.1-1) unstable; urgency=low

  * New upstream release

 -- Kari Pahula <kaol@debian.org>  Wed, 19 Mar 2008 00:25:23 +0200

gecode (2.1.0-1) unstable; urgency=low

  * New upstream release
  * Improved the examples' Makefile.

 -- Kari Pahula <kaol@debian.org>  Mon, 03 Mar 2008 07:03:35 +0200

gecode (2.0.1-1) unstable; urgency=low

  * New upstream release

 -- Kari Pahula <kaol@debian.org>  Fri, 15 Feb 2008 18:36:50 +0200

gecode (2.0.0-1) unstable; urgency=low

  * New upstream release
  * Various small fixes to make the policy and lintian happy.
  * Provided a Makefile to compile the examples.

 -- Kari Pahula <kaol@debian.org>  Wed, 09 Jan 2008 19:51:02 +0200

gecode (1.3.1-1) unstable; urgency=low

  * New upstream release
  * Added a default value for prop_bnd in int/distinct.hh to maintain API
    compatibility.

 -- Kari Pahula <kaol@debian.org>  Thu, 26 Oct 2006 11:22:28 +0300

gecode (1.3.0-1) unstable; urgency=low

  * New upstream release
  * Check for DEB_BUILD_GNU_TYPE when testing whether to run the test
    suite, not DEB_HOST_GNU_TYPE

 -- Kari Pahula <kaol@debian.org>  Wed, 20 Sep 2006 08:22:37 +0300

gecode (1.2.2-1) unstable; urgency=low

  * New upstream release
  * Use -E instead of -e with grep in the host arch check regexp in
    debian/rules (oops)
  * libgecode6-dev: Provides and Conflicts libgecode-dev

 -- Kari Pahula <kaol@debian.org>  Wed, 26 Jul 2006 06:21:09 +0300

gecode (1.2.0-1) unstable; urgency=low

  * New upstream release
    - Detects GNU/kFreeBSD correctly now (Closes: #370470)
  * Disabled running test on s390 too (Closes: #370466)
  * Moved doxygen and graphviz to Build-Depends-Indep again and tested it
    too.
  * Put all libraries to single libgecode4 package.

 -- Kari Pahula <kaol@debian.org>  Mon, 26 Jun 2006 14:06:15 +0300

gecode (1.1.0-2) unstable; urgency=low

  * Moved doxygen from Build-Depends-Indep to Build-Depends
    (Closes: #370415)

 -- Kari Pahula <kaol@debian.org>  Mon,  5 Jun 2006 11:12:21 +0300

gecode (1.1.0-1) unstable; urgency=low

  * New upstream release
    - Upstream removed the parallel stuff themselves, no need to
      repackage orig.tar.gz anymore
  * Disable running test on arm and m68k architectures.
  * Policy version 3.6.2 -> 3.7.2 (no changes necessary)

 -- Kari Pahula <kaol@debian.org>  Fri,  5 May 2006 20:56:06 +0300

gecode (1.0.1.dfsg.1-1) unstable; urgency=low

  * New upstream release
  * Added make test and test/test to the build debian/rules target.
  * Build static libraries for -dev package.
  * Removed parallel.hh and parallel/ due to unclear license from the
    orig.tar.gz tarball.

 -- Kari Pahula <kaol@iki.fi>  Sun, 26 Mar 2006 21:23:38 +0300

gecode (1.0.0.dfsg.1-2) unstable; urgency=low

  * Properly separate targets to -arch and -indep in debian/rules
    (Closes: #345332)



=== debian/control ===
Source: gecode
Priority: optional
Maintainer: Kari Pahula <kaol@debian.org>
Build-Depends: debhelper (>= 5), autotools-dev, libqt4-dev, libboost-dev, autoconf, automake
Build-Conflicts: qt3-dev-tools
Build-Depends-Indep: graphviz, doxygen
Standards-Version: 3.8.4
Section: libs
Homepage: http://www.gecode.org/

Package: libgecode-dev
Section: libdevel
Architecture: any
Depends: libgecode22 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
Suggests: libgecode-doc
Description: generic constraint development environment
 Gecode is an attempt to construct an open, free, portable, accessible,
 and efficient environment for developing constraint-based systems and
 applications.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.

Package: libgecode-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libgecode-dev
Description: generic constraint development environment
 Gecode is an attempt to construct an open, free, portable, accessible,
 and efficient environment for developing constraint-based systems and
 applications.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.
 .
 This package has the API documentation and examples.

Package: libgecode22
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libgecode-dev
Description: generic constraint development environment
 Gecode is an attempt to construct an open, free, portable, accessible,
 and efficient environment for developing constraint-based systems and
 applications.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.

## gecode 3.4.0

=== debian/changelog ===
gecode (3.4.0-1) unstable; urgency=low

  * New upstream release
  * Standards-Version 3.9.1 (no changes necessary).

 -- Kari Pahula <kaol@debian.org>  Tue, 27 Jul 2010 21:57:51 +0300

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Build-Depends: debhelper (>= 5), autotools-dev, libqt4-dev, libboost-dev, autoconf, automake
 Build-Conflicts: qt3-dev-tools
 Build-Depends-Indep: graphviz, doxygen
-Standards-Version: 3.8.4
+Standards-Version: 3.9.1
 Section: libs
 Homepage: http://www.gecode.org/
 
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode22 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
+Depends: libgecode23 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is an attempt to construct an open, free, portable, accessible,
@@ -44,7 +44,7 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode22
+Package: libgecode23
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g -Wl,-z,defs -D_REENTRANT

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
ifeq (ia64,$(DEB_HOST_ARCH))
	CFLAGS += -O2
else
	CFLAGS += -O3
endif
endif
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

configure:
	autoreconf

config.status: configure
	dh_testdir
	cp -f /usr/share/misc/config.sub config.sub
	cp -f /usr/share/misc/config.guess config.guess
	./configure --host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --disable-examples --enable-shared CFLAGS="$(CFLAGS)" CXXFLAGS="$(CFLAGS)" --enable-gist --enable-qt --enable-float-vars


build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: config.status
	dh_testdir
	if [ ! -e ChangeLog ] ; then make ChangeLog; fi
	$(MAKE) $(MAKEFLAGS)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	make check LD_LIBRARY_PATH=.
# If you want to spend hours on this, enable this
# test is disabled on those arches since it's too slow
#	-if echo $(DEB_BUILD_GNU_TYPE) | grep -vcE '^(arm|m68k)' ; then $(MAKE) test && LD_LIBRARY_PATH=. test/test ; fi
endif
	touch build-arch-stamp

# this would fail when building -arch packages (buildds do not believe
# in build-indep targets and just call build anyway)
build-indep: build-indep-stamp
build-indep-stamp: config.status
	dh_testdir
	if [ -e /usr/bin/doxygen ] ; then $(MAKE) doc ; fi
	if [ ! -e ChangeLog ] ; then make ChangeLog; fi
	touch build-indep-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp

	[ ! -f Makefile ] || $(MAKE) distclean
	rm -fr doc
	rm -f lib*.so lib*.so.?
	rm -f test/test
	rm -f ChangeLog changelog.hh Makefile.dep
	rm -f config.log config.guess config.sub
	rm -f contribs/qecode/config.log contribs/qecode/config.guess contribs/qecode/config.status
	rm -f configure gecode/support/config.hpp.in
	dh_clean 

# there's no install-indep since that has only doc which stays in doc/
install: build-arch
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr


# Build architecture-independent files here.
binary-indep: build-indep
	dh_testdir
	dh_testroot
	dh_install -i
	dh_installchangelogs -i ChangeLog
	dh_installdocs -i
	dh_installexamples -i
	chmod -x $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/*
	install -m 0644 -D debian/Makefile.examples $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/Makefile
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build-arch install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a ChangeLog
	dh_installdocs -a
	dh_install -a
	find $(CURDIR)/debian/libgecode-dev/usr/include -type f -exec chmod -x {} \;
	dh_link -a
	dh_strip
	dh_compress -a
	dh_fixperms -a
	dh_makeshlibs -V
	dh_installdeb -a
	dh_shlibdeps
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

.PHONY: build build-arch build-indep clean binary-indep binary-arch binary install

## gecode 3.5.0

=== debian/changelog ===
gecode (3.5.0-2) unstable; urgency=low

  * Merge install target with binary-arch and call dh_prep in both of
    build-{indep,arch}. (Closes: #625175)
  * Added more -l flags to the included examples/Makefile and made it
    gunzip gzipped examples.
  * Standards-Version 3.9.2 (no changes necessary).

 -- Kari Pahula <kaol@debian.org>  Sun, 10 Jul 2011 22:23:09 +0300

gecode (3.5.0-1) unstable; urgency=low

  * New upstream release (soname 27)
  * Don't install /usr/include/examples to libgecode-dev

 -- Kari Pahula <kaol@debian.org>  Sat, 05 Feb 2011 23:56:22 +0200

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Build-Depends: debhelper (>= 5), autotools-dev, libqt4-dev, libboost-dev, autoconf, automake
 Build-Conflicts: qt3-dev-tools
 Build-Depends-Indep: graphviz, doxygen
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Section: libs
 Homepage: http://www.gecode.org/
 
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode23 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
+Depends: libgecode27 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is an attempt to construct an open, free, portable, accessible,
@@ -44,7 +44,7 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode23
+Package: libgecode27
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -45,10 +45,10 @@
 build-arch: build-arch-stamp
 build-arch-stamp: config.status
 	dh_testdir
-	if [ ! -e ChangeLog ] ; then make ChangeLog; fi
+	if [ ! -e ChangeLog ] ; then $(MAKE) ChangeLog; fi
 	$(MAKE) $(MAKEFLAGS)
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	make check LD_LIBRARY_PATH=.
+	$(MAKE) check LD_LIBRARY_PATH=. $(MAKEFLAGS)
 # If you want to spend hours on this, enable this
 # test is disabled on those arches since it's too slow
 #	-if echo $(DEB_BUILD_GNU_TYPE) | grep -vcE '^(arm|m68k)' ; then $(MAKE) test && LD_LIBRARY_PATH=. test/test ; fi
@@ -79,24 +79,14 @@
 	rm -f configure gecode/support/config.hpp.in
 	dh_clean 
 
-# there's no install-indep since that has only doc which stays in doc/
-install: build-arch
-	dh_testdir
-	dh_testroot
-	dh_clean -k 
-	dh_installdirs
-
-	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
-
-
 # Build architecture-independent files here.
 binary-indep: build-indep
 	dh_testdir
 	dh_testroot
-	dh_install -i
+	dh_prep -i
 	dh_installchangelogs -i ChangeLog
 	dh_installdocs -i
-	dh_installexamples -i
+	dh_install -i
 	chmod -x $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/*
 	install -m 0644 -D debian/Makefile.examples $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/Makefile
 	dh_compress -i
@@ -107,9 +97,12 @@
 	dh_builddeb -i
 
 # Build architecture-dependent files here.
-binary-arch: build-arch install
+binary-arch: build-arch
 	dh_testdir
 	dh_testroot
+	dh_prep -a
+	dh_installdirs -a
+	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
 	dh_installchangelogs -a ChangeLog
 	dh_installdocs -a
 	dh_install -a

## gecode 3.7.1

=== debian/changelog ===
gecode (3.7.1-2) unstable; urgency=low

  * Use -O2 on mipsel to avoid FTBFS with getting stuck at building
    gecode/set/branch/post-view.cpp.

 -- Kari Pahula <kaol@debian.org>  Sun, 16 Oct 2011 11:05:58 +0300

gecode (3.7.1-1) unstable; urgency=low

  * New upstream release (soname 30)

 -- Kari Pahula <kaol@debian.org>  Wed, 12 Oct 2011 18:14:44 +0300

gecode (3.7.0-1) unstable; urgency=low

  * New upstream release (soname 29)
  * Split off libgecodegist and libgecodedriver to libgecodegist29
    package. (Closes: #625757)
  * Moved flatzinc to its own package and split off libgecodeflatzinc29 to
    a separate package too.

 -- Kari Pahula <kaol@debian.org>  Tue, 06 Sep 2011 23:22:18 +0300

gecode (3.6.0-1) unstable; urgency=low

  * New upstream release (soname 28)

 -- Kari Pahula <kaol@debian.org>  Mon, 08 Aug 2011 00:02:44 +0300

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode27 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
+Depends: libgecode30 (= ${binary:Version}), libgecodegist30 (= ${binary:Version}), libgecodeflatzinc30 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is an attempt to construct an open, free, portable, accessible,
@@ -44,7 +44,7 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode27
+Package: libgecode30
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -60,3 +60,59 @@
  and search engines. New variable domains can be programmed at the same
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
+
+Package: libgecodegist30
+Section: libs
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Suggests: libgecode-dev
+Description: Gecode Interactive Search Tool library
+ Gecode is an attempt to construct an open, free, portable, accessible,
+ and efficient environment for developing constraint-based systems and
+ applications.
+ .
+ This package contains libgecodegist, a graphical debugging tool, and
+ libgecodedriver, a set of helper classes for writing standalone
+ programs.  They have been separated from the main Gecode library
+ package to avoid pulling in Qt as a dependency.
+
+Package: libgecodeflatzinc30
+Section: libs
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Suggests: libgecode-dev
+Homepage: http://www.gecode.org/flatzinc.html
+Description: Gecode support for FlatZinc modelling language
+ Gecode is an attempt to construct an open, free, portable, accessible,
+ and efficient environment for developing constraint-based systems and
+ applications.
+ .
+ FlatZinc is a low-level modelling language for constraint
+ problems. It is designed to be easily interfaceable to constraint
+ solvers (like Gecode). For more information on FlatZinc, please refer
+ to the MiniZinc pages of the G12 project
+ <http://www.g12.cs.mu.oz.au/minizinc/>.
+
+
+Package: flatzinc
+Section: devel
+Architecture: any
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Replaces: libgecode-dev (<< 3.7.0)
+Homepage: http://www.gecode.org/flatzinc.html
+Description: constraint problem modelling language
+ FlatZinc is a low-level modelling language for constraint
+ problems. It is designed to be easily interfaceable to constraint
+ solvers (like Gecode). For more information on FlatZinc, please refer
+ to the MiniZinc pages of the G12 project
+ <http://www.g12.cs.mu.oz.au/minizinc/>.
+ .
+ We provide a parser that reads a FlatZinc model from a file, and
+ returns a Gecode Space object that represents the model. We also
+ provide a simple front-end, an executable program that reads a
+ FlatZinc model and prints the solution (if any) on the standard
+ output.
+ .
+ The FlatZinc interpreter that ships with Gecode version 3.7.1
+ supports the FlatZinc language and MiniZinc global constraint
+ definitions of MiniZinc version 1.4.0.

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,7 @@
 ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 	CFLAGS += -O0
 else
-ifeq (ia64,$(DEB_HOST_ARCH))
+ifneq (,$(filter ia64 mipsel,$(DEB_HOST_ARCH)))
 	CFLAGS += -O2
 else
 	CFLAGS += -O3

## gecode 3.7.3

=== debian/changelog ===
gecode (3.7.3-1) unstable; urgency=low

  * New upstream release (soname 32)

 -- Kari Pahula <kaol@debian.org>  Sun, 01 Apr 2012 00:16:09 +0300

gecode (3.7.2-1) unstable; urgency=low

  * New upstream release (soname 31)
  * Standards-Version 3.9.3 (no changes necessary).
  * Use cdbs and dh_autoreconf.
  * Multi-Arch: same.
  * Remove unused libboost-dev from build deps.

 -- Kari Pahula <kaol@debian.org>  Sat, 31 Mar 2012 11:33:21 +0300

gecode (3.7.1-3) unstable; urgency=low

  * Patch channel constraint posting bug
    (http://www.gecode.org/pipermail/users/2011-October/003453.html)
  * Patch sorted constraint seg faults with empty arrays
    (http://www.gecode.org/pipermail/users/2011-November/003456.html)

 -- Kari Pahula <kaol@debian.org>  Thu, 17 Nov 2011 20:17:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: gecode
 Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
-Build-Depends: debhelper (>= 5), autotools-dev, libqt4-dev, libboost-dev, autoconf, automake
+Build-Depends: debhelper (>= 8.1.3), autotools-dev, libqt4-dev, cdbs (>= 0.4.93~), dh-autoreconf
 Build-Conflicts: qt3-dev-tools
 Build-Depends-Indep: graphviz, doxygen
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Section: libs
 Homepage: http://www.gecode.org/
 
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode30 (= ${binary:Version}), libgecodegist30 (= ${binary:Version}), libgecodeflatzinc30 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
+Depends: libgecode32 (= ${binary:Version}), libgecodegist32 (= ${binary:Version}), libgecodeflatzinc32 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is an attempt to construct an open, free, portable, accessible,
@@ -44,10 +44,11 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode30
+Package: libgecode32
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
 Description: generic constraint development environment
  Gecode is an attempt to construct an open, free, portable, accessible,
@@ -61,10 +62,11 @@
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
 
-Package: libgecodegist30
+Package: libgecodegist32
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
 Description: Gecode Interactive Search Tool library
  Gecode is an attempt to construct an open, free, portable, accessible,
@@ -76,10 +78,11 @@
  programs.  They have been separated from the main Gecode library
  package to avoid pulling in Qt as a dependency.
 
-Package: libgecodeflatzinc30
+Package: libgecodeflatzinc32
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Suggests: libgecode-dev
 Homepage: http://www.gecode.org/flatzinc.html
 Description: Gecode support for FlatZinc modelling language

=== debian/rules ===
#!/usr/bin/make -f

DEB_CONFIGURE_EXTRA_FLAGS=--enable-gist --enable-qt --enable-float-vars --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
DEB_BUILD_PARALLEL=yes

include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/autoreconf.mk

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS))$(filter ia64 mipsel,$(DEB_HOST_ARCH)))
	CFLAGS += -O3
	CXXFLAGS += -O3
endif

CFLAGS += -D_REENTRANT
CXXFLAGS += -D_REENTRANT

ChangeLog:
	$(MAKE) ChangeLog

common-install-prehook-impl:: ChangeLog

build/libgecode-dev::
	$(MAKE) check LD_LIBRARY_PATH=.

build/libgecode-doc::
	if [ -e /usr/bin/doxygen ] ; then $(MAKE) doc ; fi

binary-fixup/libgecode-doc::
	find $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/ -type f -exec chmod 0644 '{}' ';'
	install -m 0644 -D debian/Makefile.examples $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/Makefile

binary-fixup/libgecode-dev::
	find $(CURDIR)/debian/libgecode-dev/usr/include -type f -exec chmod -x {} \;

common-binary-fixup-arch::
	for libso in `find debian/ -type f -regex 'debian/lib.*/lib.*\.so\.[0-9]+\.[0-9]+'`; do ln -s $${libso##*/} $${libso%.*}; done

binary/libgecode-doc::
	[ -e debian/libgecode-doc/usr/share/doc/libgecode-doc/html/ ]

## gecode 4.0.0

=== CMakeLists.txt ===
#
#  Main authors:
#     Victor Zverovich <victor.zverovich@gmail.com>
#
#  Copyright:
#     Victor Zverovich, 2013
#
#  Last modified:
#     $Date: 2013-02-20 18:36:17 +0100 (Wed, 20 Feb 2013) $ by $Author: schulte $
#     $Revision: 13349 $
#
#  This file is part of Gecode, the generic constraint
#  development environment:
#     http://www.gecode.org
#
#  Permission is hereby granted, free of charge, to any person obtaining
#  a copy of this software and associated documentation files (the
#  "Software"), to deal in the Software without restriction, including
#  without limitation the rights to use, copy, modify, merge, publish,
#  distribute, sublicense, and/or sell copies of the Software, and to
#  permit persons to whom the Software is furnished to do so, subject to
#  the following conditions:
#
#  The above copyright notice and this permission notice shall be
#  included in all copies or substantial portions of the Software.
#
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
#  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
#  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
#  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
#  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
#  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
#  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

#
# CMake build script for Gecode.
#

cmake_minimum_required(VERSION 2.6)

project(GECODE)

include(CheckCXXCompilerFlag)
if (GECODE_DISABLE_WARNINGS)
  if (CMAKE_COMPILER_IS_GNUCXX)
    add_definitions(-Wno-overloaded-virtual)
    add_definitions(-Wno-switch)
    add_definitions(-Wno-unused-parameter)
    check_cxx_compiler_flag(
      -Wno-unused-but-set-variable HAVE_WNO_UNUSED_BUT_SET_VARIABLE_FLAG)
    if (HAVE_WNO_UNUSED_BUT_SET_VARIABLE_FLAG)
      add_definitions(-Wno-unused-but-set-variable)
    endif ()
  elseif (MSVC)
    foreach (flag_var
             CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
             CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      string(REPLACE "/W3" "/w" ${flag_var} "${${flag_var}}")
    endforeach()
  endif ()
endif ()

# The following part of config.h is hard to derive from configure.ac.
file(READ gecode/support/config.hpp.in CONFIG)
string(REGEX REPLACE "^/\\*([^*]|\\*[^/])*\\*/" "" CONFIG ${CONFIG})
string(REGEX MATCHALL "[^\n]*\n" CONFIG
"${CONFIG}
/* Define to 1 if you have the `getpagesize' function. */
#undef HAVE_GETPAGESIZE

/* Define to 1 if you have the <inttypes.h> header file. */
#undef HAVE_INTTYPES_H

/* Define to 1 if you have the <memory.h> header file. */
#undef HAVE_MEMORY_H

/* Define to 1 if you have a working `mmap' system call. */
#undef HAVE_MMAP

/* Define to 1 if you have the <stdint.h> header file. */
#undef HAVE_STDINT_H

/* Define to 1 if you have the <stdlib.h> header file. */
#undef HAVE_STDLIB_H

/* Define to 1 if you have the <strings.h> header file. */
#undef HAVE_STRINGS_H

/* Define to 1 if you have the <string.h> header file. */
#undef HAVE_STRING_H

/* Define to 1 if you have the <sys/param.h> header file. */
#undef HAVE_SYS_PARAM_H

/* Define to 1 if you have the <sys/stat.h> header file. */
#undef HAVE_SYS_STAT_H

/* Define to 1 if you have the <sys/types.h> header file. */
#undef HAVE_SYS_TYPES_H

/* Define to 1 if you have the <unistd.h> header file. */
#undef HAVE_UNISTD_H

/* Define to the address where bug reports for this package should be sent. */
#undef PACKAGE_BUGREPORT

/* Define to the full name of this package. */
#undef PACKAGE_NAME

/* Define to the full name and version of this package. */
#undef PACKAGE_STRING

/* Define to the one symbol short name of this package. */
#undef PACKAGE_TARNAME

/* Define to the home page for this package. */
#undef PACKAGE_URL

/* Define to the version of this package. */
#undef PACKAGE_VERSION

/* The size of `int', as computed by sizeof. */
#undef SIZEOF_INT

/* Define to 1 if you have the ANSI C header files. */
#undef STDC_HEADERS
")

# Get version numbers and parts of config.h from configure.ac.
file(READ configure.ac LINES)
# Replace semicolons with "<semi>" to avoid CMake messing with them.
string(REPLACE ";" "<semi>" LINES "${LINES}")
# Split into lines keeping newlines to avoid foreach skipping empty ones.
string(REGEX MATCHALL "[^\n]*\n" LINES "${LINES}")
set(ah_command FALSE)
foreach (line "${EXTRA_CONFIG}" ${LINES})
  string(REPLACE ";" "" line "${line}")
  if (ah_command)
    # Do nothing.
  elseif (line MATCHES "AC_INIT\\(([^,]*), *([^,]*), *([^)]*)\\)")
    set(PACKAGE ${CMAKE_MATCH_1})
    set(VERSION ${CMAKE_MATCH_2})
    set(PACKAGE_BUGREPORT ${CMAKE_MATCH_3})
    message(STATUS "Got VERSION=${VERSION} from configure.ac")
  elseif (line MATCHES "ac_gecode_flatzincversion=(.*)\n")
    set(GECODE_FLATZINC_VERSION "${CMAKE_MATCH_1}")
  elseif (line MATCHES "AH_BOTTOM\\(\\[(.*)")
    set(ah_command bottom)
    set(line "${CMAKE_MATCH_1}")
  elseif (line MATCHES "AH_VERBATIM[^,]+,(.*)")
    set(ah_command verbatim)
    set(line "${CMAKE_MATCH_1}")
  endif ()
  if (ah_command)
    set(saved_ah_command ${ah_command})
    if (line MATCHES "^\\[(.*)")
      set(line "${CMAKE_MATCH_1}")
    endif ()
    if (line MATCHES "\\]\\)")
      set(ah_command FALSE)
      string(REPLACE "])" "" line "${line}")
    endif ()
    # For some reason CMake may bundle several lines together. Split them too.
    string(REGEX MATCHALL "[^\n]*\n" sublines "${line}")
    set(config_add "")
    foreach (subline ${sublines})
      set(config_add ${config_add} "${subline}")
    endforeach ()
    if (saved_ah_command STREQUAL "verbatim")
      set(CONFIG ${config_add} ${CONFIG})
    else ()
      set(CONFIG ${CONFIG} "\n" ${config_add})
    endif ()
  endif ()
endforeach ()
set(PACKAGE_NAME ${PACKAGE})
string(TOLOWER ${PACKAGE} PACKAGE_TARNAME)
set(PACKAGE_URL "")
set(PACKAGE_VERSION ${VERSION})
set(${PACKAGE}_VERSION ${VERSION})
string(REPLACE "." "-" GECODE_LIBRARY_VERSION "${VERSION}")
set(PACKAGE_STRING "${PACKAGE} ${VERSION}")
if (VERSION MATCHES "(.*)\\.(.*)\\.(.*)")
  math(EXPR GECODE_VERSION_NUMBER
    "${CMAKE_MATCH_1} * 100000 + ${CMAKE_MATCH_2} * 100 + ${CMAKE_MATCH_3}")
endif ()

set(GECODE_DLL_USERPREFIX "")
set(GECODE_DLL_USERSUFFIX "")
set(GECODE_HAS_INT_VARS "/**/")
set(GECODE_HAS_SET_VARS "/**/")
set(GECODE_HAS_FLOAT_VARS "/**/")
set(GECODE_STATIC_LIBS 1)

check_cxx_compiler_flag(-fvisibility=hidden HAVE_VISIBILITY_HIDDEN_FLAG)
if (HAVE_VISIBILITY_HIDDEN_FLAG)
  set(GECODE_GCC_HAS_CLASS_VISIBILITY "/**/")
endif ()

if (WIN32)
  set(GECODE_THREADS_WINDOWS 1)
else ()
  set(GECODE_THREADS_PTHREADS 1)
endif ()

find_package(Qt4)
if (QT4_FOUND)
  set(GECODE_HAS_QT "/**/")
  set(GECODE_HAS_GIST "/**/")
  set(EXTRA_LIBS gist)
  include(${QT_USE_FILE})
endif ()

include(CheckSymbolExists)
check_symbol_exists(getpagesize unistd.h HAVE_GETPAGESIZE)
check_symbol_exists(mmap sys/mman.h HAVE_MMAP)

# Checks for header files.
include(CheckIncludeFiles)
foreach (header inttypes.h memory.h stdint.h stdlib.h strings.h string.h
                sys/param.h sys/stat.h sys/time.h sys/types.h unistd.h)
  string(TOUPPER HAVE_${header} var)
  string(REGEX REPLACE "\\.|/" "_" var ${var})
  check_include_files(${header} ${var})
endforeach ()
check_include_files(stdio.h STDC_HEADERS)
if (HAVE_SYS_TIME_H)
  set(GECODE_USE_GETTIMEOFDAY 1)
else ()
  set(GECODE_USE_CLOCK 1)
endif ()
if (HAVE_UNISTD_H)
  set(GECODE_HAS_UNISTD_H 1)
endif ()

include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
   #include <ext/hash_map>
   int main() {}" HAVE_EXT_HASH_MAP)
if (HAVE_EXT_HASH_MAP)
  set(GECODE_HAS_GNU_HASH_MAP "/**/")
endif ()

include(CheckTypeSize)
check_type_size(int SIZEOF_INT)

# Check for inline.
include(CheckCSourceCompiles)
check_c_source_compiles("
  inline __attribute__ ((__always_inline__)) void foo(void) {}
  int main() {}" HAVE_ALWAYS_INLINE)
set(forceinline inline)
if (HAVE_ALWAYS_INLINE)
  set(forceinline "inline __attribute__ ((__always_inline__))")
endif ()

check_c_source_compiles("
  int main() { return __builtin_ffsl(0); }" HAVE_BUILTIN_FFSL)
if (HAVE_BUILTIN_FFSL)
  set(GECODE_HAS_BUILTIN_FFSL "/**/")
endif ()

# Process config.hpp using autoconf rules.
list(LENGTH CONFIG length)
math(EXPR length "${length} - 1")
foreach (i RANGE ${length})
  list(GET CONFIG ${i} line)
  if (line MATCHES "^#( *)undef (.*)\n")
    set(space "${CMAKE_MATCH_1}")
    set(var ${CMAKE_MATCH_2})
    if (NOT DEFINED ${var} OR (var MATCHES "HAVE_.*_H" AND NOT ${var}))
      set(line "/* #${space}undef ${var} */\n")
    else ()
      if ("${${var}}" STREQUAL "/**/" OR "${var}" STREQUAL "GECODE_VERSION_NUMBER" OR
          "${var}" STREQUAL "forceinline" OR var MATCHES "SIZEOF_.*")
        set(value ${${var}})
      elseif (NOT (var MATCHES ^HAVE OR ${var} EQUAL 0 OR ${var} EQUAL 1))
        set(value \"${${var}}\")
      elseif (${var})
        set(value 1)
      else ()
        set(value 0)
      endif ()
      set(line "#${space}define ${var} ${value}\n")
    endif ()
  endif ()
  string(REPLACE "<semi>" ";" line "${line}")
  set(CONFIG_OUT "${CONFIG_OUT}${line}")
endforeach ()
file(WRITE ${GECODE_BINARY_DIR}/gecode/support/config.hpp
"/* gecode/support/config.hpp.  Generated from config.hpp.in by configure.  */
/* gecode/support/config.hpp.in.  Generated from configure.ac by autoheader.  */

/* Disable autolink because all the dependencies are handled by CMake. */
#define GECODE_BUILD_SUPPORT
#define GECODE_BUILD_KERNEL
#define GECODE_BUILD_SEARCH
#define GECODE_BUILD_INT
#define GECODE_BUILD_SET
#define GECODE_BUILD_MINIMODEL

${CONFIG_OUT}")

# Expands a value substituting variables and appends the result to ${var}.
function (expand var value)
  if (value MATCHES "\\$\\(([^:]+)(.*)\\)")
    # Perform substitution.
    set(pattern ${CMAKE_MATCH_2})
    set(items ${${CMAKE_MATCH_1}})
    if (pattern MATCHES ":%=([^%]*)%([^%]*)")
      set(values )
      foreach (item ${items})
        set(values ${values} ${CMAKE_MATCH_1}${item}${CMAKE_MATCH_2})
      endforeach ()
    else ()
      set(values ${items})
    endif ()
  else ()
    set(values ${value})
  endif ()
  set(${var} ${${var}} ${values} PARENT_SCOPE)
endfunction ()

# Parse Makefile.in extracting variables.
file(READ Makefile.in text)
string(REPLACE "\\\n" "" text "${text}")
string(REGEX REPLACE "#[^\n]*\n" "" text "${text}")
string(REGEX MATCHALL "[^\n]+" lines "${text}")
foreach (line ${lines})
  if (line MATCHES "([^ \t]+)[ \t]*=[ \t]*(.*)")
    set(var ${CMAKE_MATCH_1})
    set(${var} )
    string(REGEX MATCHALL "[^ \t]+" items "${CMAKE_MATCH_2}")
    foreach (item ${items})
      expand(${var} ${item})
    endforeach ()
  endif ()
endforeach ()

foreach (lib support kernel search int set float
             minimodel driver flatzinc ${EXTRA_LIBS})
  if (lib STREQUAL "minimodel")
    set(libupper MM)
  else ()
    string(TOUPPER ${lib} libupper)
  endif ()
  if (${libupper}SRC)
    add_library(gecode${lib} ${${libupper}SRC} ${${libupper}HDR})
  endif ()
endforeach ()

find_package(Threads)
target_link_libraries(gecodesupport ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(gecodekernel gecodesupport)
target_link_libraries(gecodesearch gecodekernel)
target_link_libraries(gecodeint gecodekernel)
target_link_libraries(gecodeset gecodekernel)
target_link_libraries(gecodeminimodel gecodeint gecodeset gecodesearch)

if (GECODE_HAS_QT)
  target_link_libraries(gecodeflatzinc ${QT_LIBRARIES})
  target_link_libraries(gecodegist ${QT_LIBRARIES})
endif ()

if (FLOATSRC)
  target_link_libraries(gecodefloat gecodekernel)
  target_link_libraries(gecodeminimodel gecodefloat)
endif ()

include_directories(.)
add_executable(gecode-test ${TESTSRC} ${TESTHDR})
target_link_libraries(gecode-test gecodeminimodel)

enable_testing()
add_test(test gecode-test
  -iter 2 -test Branch::Int::Dense::3
  -test Int::Linear::Int::Int::Eq::Bnd::12::4
  -test Int::Distinct::Random

=== debian/changelog ===
gecode (4.0.0-2) unstable; urgency=low

  * Give make check LD_LIBRARY_PATH=. to make test work without gecode
    already installed, to fix FTBFS.

 -- Kari Pahula <kaol@debian.org>  Sat, 25 May 2013 15:57:32 +0300

gecode (4.0.0-1) unstable; urgency=low

  * New upstream release (soname 33)
  * Standards-Version 3.9.4 (no changes necessary).
  * Compress debs with xz.
  * Make sure that the hardening flags get passed to gecode's build
    scripts.
  * Added build-dep libmpfr-dev.

 -- Kari Pahula <kaol@debian.org>  Mon, 20 May 2013 22:01:23 +0300

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,17 @@
 Source: gecode
 Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
-Build-Depends: debhelper (>= 8.1.3), autotools-dev, libqt4-dev, cdbs (>= 0.4.93~), dh-autoreconf
+Build-Depends: debhelper (>= 8.1.3), autotools-dev, libqt4-dev, cdbs (>= 0.4.93~), dh-autoreconf, libmpfr-dev
 Build-Conflicts: qt3-dev-tools
 Build-Depends-Indep: graphviz, doxygen
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Section: libs
 Homepage: http://www.gecode.org/
 
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode32 (= ${binary:Version}), libgecodegist32 (= ${binary:Version}), libgecodeflatzinc32 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libboost-dev
+Depends: libgecode33 (= ${binary:Version}), libgecodegist33 (= ${binary:Version}), libgecodeflatzinc33 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, libqt4-dev, libmpfr-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is an attempt to construct an open, free, portable, accessible,
@@ -44,7 +44,7 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode32
+Package: libgecode33
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -62,7 +62,7 @@
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
 
-Package: libgecodegist32
+Package: libgecodegist33
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -78,7 +78,7 @@
  programs.  They have been separated from the main Gecode library
  package to avoid pulling in Qt as a dependency.
 
-Package: libgecodeflatzinc32
+Package: libgecodeflatzinc33
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -116,6 +116,6 @@
  FlatZinc model and prints the solution (if any) on the standard
  output.
  .
- The FlatZinc interpreter that ships with Gecode version 3.7.1
+ The FlatZinc interpreter that ships with Gecode version 4.0.0
  supports the FlatZinc language and MiniZinc global constraint
- definitions of MiniZinc version 1.4.0.
+ definitions of MiniZinc version 1.6.0.
